import { IBeeConfig, IEntityContentJson, IBeeOptions, ILoadConfig, ILoadStageMode, IUrlConfig, LoadWorkspaceOptions, IToken, BeeSaveOptions } from './types/bee';
import * as beeTypes from './types/bee';
declare class Bee {
    token: IToken;
    bee: any;
    instance: any;
    constructor(token?: IToken, urlConfig?: IUrlConfig);
    getToken: (clientId: string, clientSecret: string, urlConfig?: IUrlConfig) => Promise<any>;
    start: (config: IBeeConfig, template: IEntityContentJson | object, bucketDir?: string, options?: IBeeOptions) => Promise<unknown>;
    join: (config: IBeeConfig, sessionId: string, bucketDir?: string) => Promise<unknown>;
    executeAction: (action: string, param?: {}, options?: {}) => void;
    load: (template: IEntityContentJson) => void;
    loadRows: () => void;
    save: (options?: BeeSaveOptions) => void;
    saveAsTemplate: () => void;
    send: () => void;
    preview: () => void;
    toggleStructure: () => void;
    togglePreview: () => void;
    toggleComments: () => void;
    toggleMergeTagsPreview: () => void;
    showComment: (comment: any) => void;
    reload: (template: IEntityContentJson, options?: IBeeOptions) => void;
    loadWorkspace: (type: LoadWorkspaceOptions) => void;
    loadStageMode: (args: ILoadStageMode) => void;
    loadConfig: (args: ILoadConfig) => void;
    updateToken: (updateTokenArgs: IToken) => void;
}
export default Bee;
export { beeTypes };
