"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TokenStatus = exports.BeePluginRoles = exports.WorkspaceStage = exports.OnCommentChangeEnum = exports.OnInfoDetailHandle = exports.EngageHandle = exports.RowLayoutType = exports.ModuleDescriptorOrderNames = exports.ModuleDescriptorNames = exports.ModuleTypes = exports.BeePluginErrorCodes = exports.LoadWorkspaceOptions = exports.StageDisplayOptions = exports.StageModeOptions = void 0;
var StageModeOptions;
(function (StageModeOptions) {
    StageModeOptions["DESKTOP"] = "desktop";
    StageModeOptions["MOBILE"] = "mobile";
})(StageModeOptions = exports.StageModeOptions || (exports.StageModeOptions = {}));
var StageDisplayOptions;
(function (StageDisplayOptions) {
    StageDisplayOptions["BLUR"] = "blur";
    StageDisplayOptions["HIDE"] = "hide";
})(StageDisplayOptions = exports.StageDisplayOptions || (exports.StageDisplayOptions = {}));
var LoadWorkspaceOptions;
(function (LoadWorkspaceOptions) {
    LoadWorkspaceOptions["DEFAULT"] = "default";
    LoadWorkspaceOptions["MIXED"] = "mixed";
    LoadWorkspaceOptions["AMP_ONLY"] = "amp_only";
    LoadWorkspaceOptions["HTML_ONLY"] = "html_only";
})(LoadWorkspaceOptions = exports.LoadWorkspaceOptions || (exports.LoadWorkspaceOptions = {}));
var BeePluginErrorCodes;
(function (BeePluginErrorCodes) {
    BeePluginErrorCodes[BeePluginErrorCodes["SAVE_UNAVAILABLE"] = 1000] = "SAVE_UNAVAILABLE";
    BeePluginErrorCodes[BeePluginErrorCodes["AMP_CONTENT_DETECTED"] = 1001] = "AMP_CONTENT_DETECTED";
    BeePluginErrorCodes[BeePluginErrorCodes["INVALID_TEMPLATES"] = 1100] = "INVALID_TEMPLATES";
    BeePluginErrorCodes[BeePluginErrorCodes["TEMPLATE_CANNOT_SAVED"] = 1200] = "TEMPLATE_CANNOT_SAVED";
    BeePluginErrorCodes[BeePluginErrorCodes["LOCKED_ROW_CLICKED"] = 1300] = "LOCKED_ROW_CLICKED";
    BeePluginErrorCodes[BeePluginErrorCodes["LOCKED_MODULE_CLICKED"] = 1310] = "LOCKED_MODULE_CLICKED";
    BeePluginErrorCodes[BeePluginErrorCodes["WORKSPACE_NOT_AVAILABLE"] = 1002] = "WORKSPACE_NOT_AVAILABLE";
    BeePluginErrorCodes[BeePluginErrorCodes["GENERIC_BUMP_ERROR"] = 2000] = "GENERIC_BUMP_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["INVALID_TARGET_VERSION"] = 2100] = "INVALID_TARGET_VERSION";
    BeePluginErrorCodes[BeePluginErrorCodes["VALIDATION_ERROR_DETAIL"] = 2200] = "VALIDATION_ERROR_DETAIL";
    BeePluginErrorCodes[BeePluginErrorCodes["MISSING_TEMPLATE_VERSION"] = 2300] = "MISSING_TEMPLATE_VERSION";
    BeePluginErrorCodes[BeePluginErrorCodes["INVALID_TEMPLATE_VERSION"] = 2400] = "INVALID_TEMPLATE_VERSION";
    BeePluginErrorCodes[BeePluginErrorCodes["TRASFORMATION_ERROR"] = 2500] = "TRASFORMATION_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["BACKWARD_TRASFORMATION_ERROR"] = 2600] = "BACKWARD_TRASFORMATION_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["SERVICE_ERROR"] = 3000] = "SERVICE_ERROR";
    //File System provider errors
    BeePluginErrorCodes[BeePluginErrorCodes["FSP_GENERIC_ERROR"] = 3001] = "FSP_GENERIC_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["FSP_BE_GENERIC_ERROR"] = 3100] = "FSP_BE_GENERIC_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["FSP_RESOURCE_NOT_FOUND"] = 3200] = "FSP_RESOURCE_NOT_FOUND";
    BeePluginErrorCodes[BeePluginErrorCodes["FSP_PERMISSION_DENIED"] = 3300] = "FSP_PERMISSION_DENIED";
    BeePluginErrorCodes[BeePluginErrorCodes["FSP_RESOURCE_ALREADY_EXIST"] = 3400] = "FSP_RESOURCE_ALREADY_EXIST";
    BeePluginErrorCodes[BeePluginErrorCodes["FSP_FILE_NOT_UPLOADED"] = 3450] = "FSP_FILE_NOT_UPLOADED";
    BeePluginErrorCodes[BeePluginErrorCodes["FSP_REQUEST_ERROR"] = 3500] = "FSP_REQUEST_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["FSP_USER_ERROR"] = 3600] = "FSP_USER_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["FSP_WRONG_CREDENTIALS"] = 3650] = "FSP_WRONG_CREDENTIALS";
    //Auth Errors
    BeePluginErrorCodes[BeePluginErrorCodes["AUTH_HEADER_MISSING"] = 4001] = "AUTH_HEADER_MISSING";
    BeePluginErrorCodes[BeePluginErrorCodes["AUTH_BEARER_INVALID"] = 4005] = "AUTH_BEARER_INVALID";
    BeePluginErrorCodes[BeePluginErrorCodes["AUTH_TOKEN_EXPIRED"] = 4010] = "AUTH_TOKEN_EXPIRED";
    //Bump error
    BeePluginErrorCodes[BeePluginErrorCodes["BUMP_SERVICE_ERROR"] = 4015] = "BUMP_SERVICE_ERROR";
    //JSON pre-processing errors
    BeePluginErrorCodes[BeePluginErrorCodes["JSON_GENERIC_ERROR"] = 4101] = "JSON_GENERIC_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["JSON_CODE_TAG_ERROR"] = 4105] = "JSON_CODE_TAG_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["JSON_HTML_BLOCK_ERROR"] = 4110] = "JSON_HTML_BLOCK_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["JSON_CONDITIONAL_STATEMENT_ERROR"] = 4115] = "JSON_CONDITIONAL_STATEMENT_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["JSON_ADD_ROW_CONDITIONAL_STATEMENT_ERROR"] = 4120] = "JSON_ADD_ROW_CONDITIONAL_STATEMENT_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["JSON_ADD_ROW_STYLE_ERROR"] = 4125] = "JSON_ADD_ROW_STYLE_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["JSON_ADD_ROW_CLASS_ERROR"] = 4130] = "JSON_ADD_ROW_CLASS_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["JSON_ADD_ROW_COMPUTED_STYLE_ERROR"] = 4135] = "JSON_ADD_ROW_COMPUTED_STYLE_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["JSON_CELL_WIDTH_ERROR"] = 4140] = "JSON_CELL_WIDTH_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["JSON_ADD_COLUMN_BACKGROUND_ERROR"] = 4145] = "JSON_ADD_COLUMN_BACKGROUND_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["JSON_MAIN_CSS_ERROR"] = 4190] = "JSON_MAIN_CSS_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["JSON_MAIN_CSS_MEDIA_ERROR"] = 4191] = "JSON_MAIN_CSS_MEDIA_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["JSON_SPECIFIC_CSS_ERROR"] = 4192] = "JSON_SPECIFIC_CSS_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["JSON_CSS_RULE_ERROR"] = 4501] = "JSON_CSS_RULE_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["JSON_CSS_GENERALE_PAGE_ERROR"] = 4502] = "JSON_CSS_GENERALE_PAGE_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["JSON_BODY_CSS_ERROR"] = 4503] = "JSON_BODY_CSS_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["JSON_COVERTING_CSS_ERROR"] = 4504] = "JSON_COVERTING_CSS_ERROR";
    //HTML creation errors
    BeePluginErrorCodes[BeePluginErrorCodes["HTML_TO_JSON_CONVERT_ERROR"] = 4201] = "HTML_TO_JSON_CONVERT_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["HTML_COMMUNICATION_TO_JSON__ERROR"] = 4202] = "HTML_COMMUNICATION_TO_JSON__ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["HTML_COMMUNICATION_WORKER_TEXT_ERROR"] = 4210] = "HTML_COMMUNICATION_WORKER_TEXT_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["HTML_TEXT_ERROR"] = 4211] = "HTML_TEXT_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["HTML_COMMUNICATION_WORKER_BUTTON_ERROR"] = 4220] = "HTML_COMMUNICATION_WORKER_BUTTON_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["HTML_BUTTON_ERROR"] = 4221] = "HTML_BUTTON_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["HTML_COMMUNICATION_WORKER_VIDEO_ERROR"] = 4230] = "HTML_COMMUNICATION_WORKER_VIDEO_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["HTML_VIDEO_ERROR"] = 4231] = "HTML_VIDEO_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["HTML_COMMUNICATION_WORKER_SOCIAL_ERROR"] = 4240] = "HTML_COMMUNICATION_WORKER_SOCIAL_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["HTML_SOCIAL_ERROR"] = 4241] = "HTML_SOCIAL_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["HTML_COMMUNICATION_WORKER_ICON_ERROR"] = 4242] = "HTML_COMMUNICATION_WORKER_ICON_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["HTML_ICON_ERROR"] = 4243] = "HTML_ICON_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["HTML_COMMUNICATION_WORKER_MENU_ERROR"] = 4244] = "HTML_COMMUNICATION_WORKER_MENU_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["HTML_MENU_ERROR"] = 4245] = "HTML_MENU_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["HTML_COMMUNICATION_WORKER_IMAGE_ERROR"] = 4250] = "HTML_COMMUNICATION_WORKER_IMAGE_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["HTML_IMAGE_ERROR"] = 4251] = "HTML_IMAGE_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["HTML_COMMUNICATION_WORKER_MG_ERROR"] = 4260] = "HTML_COMMUNICATION_WORKER_MG_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["HTML_CUSTOM_ADDON_ERROR"] = 4270] = "HTML_CUSTOM_ADDON_ERROR";
    //POST-PROCESSING
    BeePluginErrorCodes[BeePluginErrorCodes["HTML_POST_GENERIC_ERROR"] = 4301] = "HTML_POST_GENERIC_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["HTML_POST_IMAGE_URI_ERROR"] = 4310] = "HTML_POST_IMAGE_URI_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["HTML_POST_CUSTOM_HTML_ERROR"] = 4320] = "HTML_POST_CUSTOM_HTML_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["HTML_POST_CUSTOM_CODE_TAG_ERROR"] = 4330] = "HTML_POST_CUSTOM_CODE_TAG_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["HTML_POST_DISPLAY_CONDITION"] = 4340] = "HTML_POST_DISPLAY_CONDITION";
    //RENDERING ERRORS
    BeePluginErrorCodes[BeePluginErrorCodes["RENDER_GENERIC_ERROR"] = 4600] = "RENDER_GENERIC_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["RENDER_CLEAN_HTML_ERROR"] = 4601] = "RENDER_CLEAN_HTML_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["RENDER_CLEAN_TEXT_ERROR"] = 4602] = "RENDER_CLEAN_TEXT_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["RENDER_CHECK_FORM_ERROR"] = 4603] = "RENDER_CHECK_FORM_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["RENDER_VALIDATION_ERROR"] = 4604] = "RENDER_VALIDATION_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["RENDER_VIDEO_FORMAT_NOT_SUPPORTED_ERROR"] = 4605] = "RENDER_VIDEO_FORMAT_NOT_SUPPORTED_ERROR";
    BeePluginErrorCodes[BeePluginErrorCodes["POST_PROCESSING_FINAL_PAGE_ERROR"] = 4700] = "POST_PROCESSING_FINAL_PAGE_ERROR";
    //SESSION TOKEN ERRORS
    BeePluginErrorCodes[BeePluginErrorCodes["EXPIRED_TOKEN_CANNOT_REFRESHED"] = 5101] = "EXPIRED_TOKEN_CANNOT_REFRESHED";
    BeePluginErrorCodes[BeePluginErrorCodes["EXPIRED_TOKEN_MUST_REFRESHED"] = 5102] = "EXPIRED_TOKEN_MUST_REFRESHED";
})(BeePluginErrorCodes = exports.BeePluginErrorCodes || (exports.BeePluginErrorCodes = {}));
exports.ModuleTypes = {
    DIVIDER: 'mailup-bee-newsletter-modules-divider',
    TEXT: 'mailup-bee-newsletter-modules-text',
    IMAGE: 'mailup-bee-newsletter-modules-image',
    BUTTON: 'mailup-bee-newsletter-modules-button',
    HTML: 'mailup-bee-newsletter-modules-html',
    SOCIAL: 'mailup-bee-newsletter-modules-social',
    EMPTY: 'mailup-bee-newsletter-modules-empty',
    VIDEO: 'mailup-bee-newsletter-modules-video',
    ADDON: 'mailup-bee-newsletter-modules-addon',
    FORM: 'mailup-bee-newsletter-modules-form',
    MERGE_CONTENT: 'mailup-bee-newsletter-modules-merge-content',
    CAROUSEL: 'mailup-bee-newsletter-modules-carousel',
    MENU: 'mailup-bee-newsletter-modules-menu',
    ICONS: 'mailup-bee-newsletter-modules-icons',
    HEADING: 'mailup-bee-newsletter-modules-heading',
    SPACER: 'mailup-bee-newsletter-modules-spacer',
    PARAGRAPH: 'mailup-bee-newsletter-modules-paragraph',
    LIST: 'mailup-bee-newsletter-modules-list'
};
exports.ModuleDescriptorNames = {
    DIVIDER: 'divider',
    TEXT: 'text',
    IMAGE: 'image',
    BUTTON: 'button',
    HTML: 'html',
    SOCIAL: 'social',
    VIDEO: 'video',
    ADDON: 'addon',
    FORM: 'form',
    MERGE_CONTENT: 'mergeContent',
    CAROUSEL: 'carousel',
    MENU: 'menu',
    ICONS: 'icons',
    HEADING: 'heading',
    SPACER: 'spacer',
    PARAGRAPH: 'paragraph',
    LIST: 'list'
};
exports.ModuleDescriptorOrderNames = {
    DIVIDER: 'Divider',
    TEXT: 'Text',
    IMAGE: 'Image',
    BUTTON: 'Button',
    HTML: 'Html',
    SOCIAL: 'Social',
    VIDEO: 'Video',
    FORM: 'Form',
    MERGE_CONTENT: 'MergeContent',
    CAROUSEL: 'Carousel',
    MENU: 'Menu',
    ICONS: 'Icons',
    HEADING: 'Heading',
    SPACER: 'Spacer',
    PARAGRAPH: 'Paragraph',
    LIST: 'List'
};
exports.RowLayoutType = {
    ONE_COLUMNS_EMPTY: 'one-column-empty',
    TWO_COLUMNS_EMPTY: 'two-columns-empty',
    TWO_COLUMNS_4_8_EMPTY: 'two-columns-4-8-empty',
    TWO_COLUMNS_8_4_EMPTY: 'two-columns-8-4-empty',
    TWO_COLUMNS_3_9_EMPTY: 'two-columns-3-9-empty',
    TWO_COLUMNS_9_3_EMPTY: 'two-columns-9-3-empty',
    THREE_COLUMNS_EMPTY: 'three-columns-empty',
    THREE_COLUMNS_3_3_6_EMPTY: 'three-columns-3-3-6-empty',
    THREE_COLUMNS_3_6_3_EMPTY: 'three-columns-3-6-3-empty',
    THREE_COLUMNS_6_3_3_EMPTY: 'three-columns-6-3-3-empty',
    FOUR_COLUMNS_EMPTY: 'four-columns-empty',
    SIX_COLUMNS_EMPTY: 'six-columns-empty',
};
var EngageHandle;
(function (EngageHandle) {
    EngageHandle["MDM"] = "mdm";
})(EngageHandle = exports.EngageHandle || (exports.EngageHandle = {}));
var OnInfoDetailHandle;
(function (OnInfoDetailHandle) {
    OnInfoDetailHandle["AI_INTEGRATION"] = "ai-integration";
})(OnInfoDetailHandle = exports.OnInfoDetailHandle || (exports.OnInfoDetailHandle = {}));
var OnCommentChangeEnum;
(function (OnCommentChangeEnum) {
    OnCommentChangeEnum["NEWCOMMENT"] = "NEW_COMMENT";
    OnCommentChangeEnum["DELETECOMMENT"] = "COMMENT_DELETED";
    OnCommentChangeEnum["CHANGECOMMENT"] = "COMMENT_EDITED";
    OnCommentChangeEnum["THREADRESOLVED"] = "COMMENT_THREAD_RESOLVED";
    OnCommentChangeEnum["THREADREOPENED"] = "COMMENT_THREAD_REOPENED";
})(OnCommentChangeEnum = exports.OnCommentChangeEnum || (exports.OnCommentChangeEnum = {}));
var WorkspaceStage;
(function (WorkspaceStage) {
    WorkspaceStage["desktop"] = "desktop";
    WorkspaceStage["mobile"] = "mobile";
    WorkspaceStage["global"] = "global";
})(WorkspaceStage = exports.WorkspaceStage || (exports.WorkspaceStage = {}));
var BeePluginRoles;
(function (BeePluginRoles) {
    BeePluginRoles["REVIEWER"] = "reviewer";
})(BeePluginRoles = exports.BeePluginRoles || (exports.BeePluginRoles = {}));
var TokenStatus;
(function (TokenStatus) {
    TokenStatus["OK"] = "ok";
    TokenStatus["REFRESHING"] = "refreshing";
})(TokenStatus = exports.TokenStatus || (exports.TokenStatus = {}));
//# sourceMappingURL=bee.js.map