"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.eitherCanExecuteAction = exports.eitherCheckStartParams = exports.eitherCheckJoinParams = void 0;
var E = __importStar(require("fp-ts/lib/Either"));
var function_1 = require("fp-ts/lib/function");
var Constants_1 = __importDefault(require("./Constants"));
var eitherHasConfig = function (config) { return !config ? E.left(new Error('Config is missing')) : E.right(config); };
var eitherHasSessionId = function (sessionId) { return !sessionId ? E.left(new Error('SessionId is missing')) : E.right(sessionId); };
var eitherHasToken = function (token) { return !token || !token.access_token ? E.left(new Error('Malformed or undefined token, call getToken() or pass your token on new BEE')) : E.right(token); };
var eitherCheckJoinParams = function (config, sessionId, token) { return (0, function_1.pipe)(eitherHasSessionId(sessionId), E.chain(function () { return eitherHasConfig(config); }), E.chain(function () { return eitherHasToken(token); })); };
exports.eitherCheckJoinParams = eitherCheckJoinParams;
var eitherCheckStartParams = function (config, token) { return (0, function_1.pipe)(eitherHasConfig(config), E.chain(function () { return eitherHasToken(token); })); };
exports.eitherCheckStartParams = eitherCheckStartParams;
var eitherBeeInstanceExist = function (instance) { return !instance ? E.left(new Error('Bee is not started')) : E.right(instance); };
var eitherIsValidAction = function (action) { return !Object.keys(Constants_1.default).some(function (x) { return Constants_1.default[x] === action; }) ? E.left(new Error("".concat(action, " is not a correct method"))) : E.right(action); };
var eitherCanExecuteAction = function (instance, action) { return (0, function_1.pipe)(eitherBeeInstanceExist(instance), E.chain(function () { return eitherIsValidAction(action); })); };
exports.eitherCanExecuteAction = eitherCanExecuteAction;
//# sourceMappingURL=utils.js.map